#include <fstream>
#include <iostream>
#include <cstring>

using namespace std;

const int MOD = 1e9 + 7;

const int Nmax = 100;

int dp[2][2][Nmax+2][Nmax+2][2*Nmax+10];
int comb[2*Nmax+10][2*Nmax+10];

void Pascal(int lim) {
    comb[0][0] = 1;
    for (int i = 1; i <= lim; i++) {
        comb[i][0] = 1;
        for (int j = 1; j <= i; j++) {
            comb[i][j] = comb[i - 1][j - 1] + comb[i - 1][j];
            if (comb[i][j] >= MOD)
                comb[i][j] -= MOD;
        }
    }
}

int main() {
    ifstream cin("piruete.in");
    ofstream cout("piruete.out");

    int T, N, K, ans = 0;
    cin >> T >> N >> K;
    Pascal(2 * N + 2);
    dp[0][1][0][0][0] = 1;
    if (T == 0) {
        ans += comb[2 * N][K];
    }
    if (T == 2 * N + 2) {
        ans += comb[N][K] % MOD;
    }
    int lim = 0;
    for (int k = 0; k < K; k++) {
        lim = lim + k;
        if (lim > T)
            break;
        int k1 = k % 2, k2 = (k + 1) % 2;
        for (int dir = 0; dir < 2; dir++) {
            for (int l = 0; l <= N; l++) {
                for (int r = 0; r <= N; r++) {
                    for (int t = 0; t < T / 2; t++) {
                        if (dir == 0) {
                                dp[k1][dir][l + 1][r][t] = dp[k1][dir][l + 1][r][t] + dp[k1][dir][l][r][t];
                                if (dp[k1][dir][l + 1][r][t] >= MOD)
                                    dp[k1][dir][l + 1][r][t] -= MOD;
                        }
                        else {
                                dp[k1][dir][l][r + 1][t] = dp[k1][dir][l][r + 1][t] + dp[k1][dir][l][r][t];
                                if (dp[k1][dir][l][r + 1][t] >= MOD)
                                    dp[k1][dir][l][r + 1][t] -= MOD;
                        }
                    }
                }
            }
        }
        memset(dp[k2], 0, sizeof(dp[k2]));
        for (int dir = 0; dir < 2; dir++) {
            for (int l = 0; l <= N; l++) {
                for (int r = 0; r <= N; r++) {
                    for (int t = 0; t <= T/2 && ((dir == 0 && t + l + 1 <= T/2) || (dir == 1 && t + r + 1 <= T/2)); t++) {
                        if (dir == 0) {
                                dp[k2][!dir][l + 1][r][t + l + 1] = dp[k2][!dir][l + 1][r][t + l + 1] +  dp[k1][dir][l][r][t];
                                if (dp[k2][!dir][l + 1][r][t + l + 1] >= MOD)
                                    dp[k2][!dir][l + 1][r][t + l + 1] -= MOD;
                        }
                        else {
                                dp[k2][!dir][l][r + 1][t + r + 1] = dp[k2][!dir][l][r + 1][t + r + 1] + dp[k1][dir][l][r][t];
                                if (dp[k2][!dir][l][r + 1][t + r + 1] >= MOD)
                                    dp[k2][!dir][l][r + 1][t + r + 1] -= MOD;
                        }
                    }
                }
            }
        }
        for (int dir = 0; dir < 2; dir++) {
            for (int l = 0; l <= N; l++) {
                for (int r = 0; r <= N; r++) {
                    ans = ans + 1ll * dp[k2][dir][l][r][T / 2] * comb[2 * N - l - r][K - (k + 1)] % MOD;
                    if (ans >= MOD)
                        ans -= MOD;
                }
            }
        }
    }
    cout << ans << "\n";
    return 0;
}
