#include <bits/stdc++.h>
using namespace std;
ifstream in("piruete.in");
ofstream out("piruete.out");
const int MOD = 1e9+7;
const int Nmax = 100 + 5;
void extd(int &x,int a){x=(1LL*x+a)%MOD;}

int p[Nmax][2*Nmax][Nmax];
int comb[2*Nmax][2*Nmax];
int upd[2*Nmax][2*Nmax];
int ans[2*Nmax],Av[2*Nmax];
int T,m,K;

int main(){
    in>>T>>m>>K;

    /// p[ M ][ N ][ K ] = din primele M pozitii am ales K ce dau suma N
    for(int M=0;M<=m;M++) p[M][0][0]=1;
    for(int M=1;M<=m+1;M++){
        for(int n=1;n<=T;n++){
            for(int k=1;k<=min(K,n);k++){
                p[M][n][k] = ( 1LL * p[M-1][n-k][k-1] + p[M-1][n-k][k] )%MOD;
            }
        }
    }

    /// precalculare combinari (folosite pana in 2*m, nr max de k-uri) 
    comb[0][0]=1;
    for(int n=1;n<=2*m+2;n++)
        for(int k=0;k<=2*m+2;k++)
            comb[n][k] = ( 1LL * comb[n-1][k-1] + comb[n-1][k] )%MOD;

    /// solutiile cu un singur obstacol, cazuri particulare
    if(T==0){
        for(int i=0;i<=2*m;i++) extd(ans[i],comb[2*m][i]);
    }
    else if(T==2*m+2){
        for(int i=0;i<=m;i++) extd(ans[i],comb[m][i]);    
    }
    else{
        for(int i=0;i<=2*m-(T/2);i++) extd(ans[i+1],comb[2*m-(T/2)][i]);
    }

    /// Av[st],Av[dr] = distanta minima necesara numarului de obstacole
    for(int j=1;j<=2*m;j++) Av[j]=Av[j-1]+j;

    /// numarul de obstacole pe care ajung sa le ating ( <= SQRT )
    for(int k=2;k<=K;k++){
        /// st->obstacole stanga, dr->obstacole dreapta
        int st=k/2,dr=k-st;
        if(st<1 || dr<1) continue;
        /// distanta totala pe care o am de impartit (cu dus si intors)
        /// in realitate egal 2*dist
        int dist = T/2;

        for(int a=Av[st];a<=dist-Av[dr];a++){
            /// a,b = cantitatea de "dist" pe care o aloc celor doua directii
            int b=dist-a;

            for(int X=st/*max(st,a-Ast-1)*/;X<=a;X++){
                for(int Y=dr/*max(dr,b-Adr-1)*/;Y<=b;Y++){
                    /// X,Y = pozitia ultimului ales pe cele doua directii
                    long long val = 1LL*p[X-1][a-X][st-1]*p[Y-1][b-Y][dr-1];

                    /// dl = numarul de pozitii despre care nu stim nimic
                    int dl=2*m-X-Y;

                    /// incrementare solutie : updatel la pozitia=k cu lungimea=dl de weight=val
                    extd(upd[k][dl],val);
                }
            }
        }
    }
    for(int k=0;k<=2*m;k++){
        for(int dl=0;dl<=2*m;dl++){
            if(upd[k][dl]){
                for(int i=0;i<=dl;i++) extd(ans[k+i],int((1LL * upd[k][dl] * comb[dl][i])%MOD));
            }
        }
    }
    out<<ans[K]<<'\n';
    return 0;
}